/*
  cgi-util.c
  
  created by Bill Kendrick
  kendrick@zippy.sonoma.edu
  http://zippy.sonoma.edu/~kendrick/
  
  based on "post-query.c" and "query.c" by NCSA
  
  New Breed Software
  
  April 6, 1996 / Sept. 22, 1996
*/

#include <stdio.h>

#ifndef NO_STDLIB_H
#include <stdlib.h>
#else
char *getenv();
#endif

#include <string.h>
#include "cgi-util.h"

#define LF 10
#define CR 13

void getword(char *word, char *line, char stop)
{
  int x, y;
  
  for(x = 0; ((line[x]) && (line[x] != stop)); x++)
    word[x] = line[x];
  
  word[x] = '\0';
  if (line[x])
    ++x;
  y=0;
  
  while (line[y++] = line[x++]);
}

char *makeword(char *line, char stop)
{
  int x,y;
  char *word = (char *) malloc(sizeof(char) * (strlen(line) + 1));
  
  for(x = 0; ((line[x]) && (line[x] != stop)); x++)
    word[x] = line[x];

  word[x] = '\0';
  if (line[x])
    ++x;
  y=0;
  
  while (line[y++] = line[x++]);
  
  return word;
}

char *fmakeword(FILE *f, char stop, int *cl)
{
  int wsize;
  char *word;
  int ll;
  
  wsize = 102400;
  ll=0;
  word = (char *) malloc(sizeof(char) * (wsize + 1));
  
  while (1)
    {
      word[ll] = (char)fgetc(f);
      if (ll==wsize)
	{
	  word[ll+1] = '\0';
	  wsize += 102400;
	  word = (char *)realloc(word,sizeof(char)*(wsize+1));
        }
      --(*cl);
      if ((word[ll] == stop) || (feof(f)) || (!(*cl)))
	{
	  if (word[ll] != stop)
	    ll++;
	  word[ll] = '\0';
	  return word;
        }
      ++ll;
    }
}

char x2c(char *what)
{
  register char digit;
  
  digit = (what[0] >= 'A' ? ((what[0] & 0xdf) - 'A')+10 : (what[0] - '0'));
  digit *= 16;
  digit += (what[1] >= 'A' ? ((what[1] & 0xdf) - 'A')+10 : (what[1] - '0'));
  return (digit);
}

void unescape_url(char *url)
{
  register int x,y;
  
  for (x=0, y=0; url[y]; ++x, ++y)
    {
      if ((url[x] = url[y]) == '%')
	{
	  url[x] = x2c(&url[y+1]);
	  y+=2;
        }
    }
  url[x] = '\0';
}

void plustospace(char *str)
{
  register int x;
  
  for (x=0; str[x]; x++)
    if (str[x] == '+')
      str[x] = ' ';
}

int rind(char *s, char c)
{
  register int x;
  
  for (x = strlen(s) - 1; x != -1; x--)
    if(s[x] == c) return x;
  return -1;
}

int getline(char *s, int n, FILE *f)
{
  register int i=0;
  
  while(1)
    {
      s[i] = (char)fgetc(f);
      
      if (s[i] == CR)
	s[i] = fgetc(f);
      
      if ((s[i] == 0x4) || (s[i] == LF) || (i == (n-1)))
	{
	  s[i] = '\0';
	  return (feof(f) ? 1 : 0);
        }
      ++i;
    }
}

void send_fd(FILE *f, FILE *fd)
{
  int num_chars=0;
  char c;
  
  while (1)
    {
      c = fgetc(f);
      if(feof(f))
	return;
      fputc(c,fd);
    }
}

int ind(char *s, char c)
{
  register int x;
  
  for (x=0; s[x]; x++)
    if(s[x] == c)
      return x;
  
  return -1;
}

void escape_shell_cmd(char *cmd)
{
  register int x,y,l;
  
  l=strlen(cmd);
  for (x=0; cmd[x]; x++)
    {
      if (ind("&;`'\"|*?~<>^()[]{}$\\",cmd[x]) != -1)
	{
	  for(y = l + 1; y > x; y--)
	    cmd[y] = cmd[y-1];
	  l++;
	  cmd[x] = '\\';
	  x++;
        }
    }
}

void cgiinit(void)
{
  register int x;
  int cl;
  char * qcl;
  
  if (getenv("REQUEST_METHOD") == NULL)
    {
      printf("Must be used via HTTP\n");
      exit(0);
    }
  
  if (strcmp(getenv("REQUEST_METHOD"),"POST") == 0)
    {
      if(strcmp(getenv("CONTENT_TYPE"),"application/x-www-form-urlencoded"))
	{
	  printf("Content-type: text/html\n\n");
	  printf("<h1>Incorrect Type</h1>\n");
	  printf("Type must be 'application/x-www-form-urlencoded'.\n");
	  
	  exit(0);
	}
      
      cl = atoi(getenv("CONTENT_LENGTH"));

      for (x = 0; cl && (!feof(stdin)); x++)
	{
	  NUM_ENTRIES = x;
	  strcpy(entries[x].val, fmakeword(stdin,'&',&cl));
	  plustospace(entries[x].val);
	  unescape_url(entries[x].val);
	  strcpy(entries[x].name, makeword(entries[x].val,'='));
	}
    }
  else if (strcmp(getenv("REQUEST_METHOD"),"GET") == 0)
    {
      qcl = getenv("QUERY_STRING");
      if (qcl == NULL)
	exit(0);
      
      for (x = 0; qcl[0] != '\0'; x++)
	{
	  NUM_ENTRIES = x;
	  getword(entries[x].val, qcl, '&');
	  plustospace(entries[x].val);
	  unescape_url(entries[x].val);
	  getword(entries[x].name, entries[x].val, '=');
	}
    }
  else
    {
      printf("Content-type: text/html\n\n");
      printf("<h1>Unknown method</h1>\n");
      printf("The form was submitted with an unknown method!\n");
      
      exit(0);
    }
}

void getentry(char * buf, char *s)
{
  int x;
  
  strcpy(buf,"");
  
  for (x = 0; x <= NUM_ENTRIES; x++)
    if (strcmp(entries[x].name,s) == 0)
      strcpy(buf,entries[x].val);
}

int getentryasint(char *s)
{
  int x, v;
  
  v = 0;
  
  for (x = 0; x <= NUM_ENTRIES; x++)
    if (strcmp(entries[x].name,s) == 0)
      v = atoi(entries[x].val);
  
  return(v);
}

int getentryyesno(char *s, int def)
{
  int x, v;
 
  v = def;
  
  for (x = 0; x <= NUM_ENTRIES; x++)
    if (strcmp(entries[x].name,s) == 0)
      {
	if (strcasecmp(entries[x].val, "yes") == 0 ||
	    strcasecmp(entries[x].val, "on") == 0)
	  v = 1;
	else if (strcasecmp(entries[x].val, "no") == 0 ||
		 strcasecmp(entries[x].val, "off") == 0)
	  v = 0;
      }
  
  return(v);
}
